// openGL_test1.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//

#include <stdafx.h>
#include <windows.h>							// Header File For Windows
#include <gl\gl.h>								// Header File For The OpenGL32 Library
#include <gl\glut.h>								// Header File For The GLu32 Library
#include "HeightField.h"


//--------------------------------------------------------------
// RENDERING
//--------------------------------------------------------------
HeightField theField;		// the heightfield !

void renderScene(void) {
	// clearing the depth buffer is necessary !
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	// choose between GL_LINES and GL_FILL for wireframe or solid triangles
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	
	
	int tSize = theField.getSize();
	float hmin=theField.getMinHeight();
	float hmax=theField.getMaxHeight();
	float colorRange=hmax-hmin;

	float scale = 1.5;
	// The brightness of the color is defined by the height,
	// low=blue, high=red
	float vx,vy,vz,color;
	for (int c=0;c<theField.m_terrainSize-1;c++){
		glBegin(GL_TRIANGLE_STRIP);
			for (int r=0;r<theField.m_terrainSize;r++){
				vx=c; vy=r; vz=theField.m_terrain[r][c];
				color=(vz-hmin)/colorRange;
				glColor3f(color,0,1-color);
				glVertex3f(vx/tSize*scale-0.7,vy/tSize*scale-0.7,-vz/tSize*scale);
				
				vx=c+1.0; vz=theField.m_terrain[r][c+1];
				color=(vz-hmin)/colorRange;
				glColor3f(color,0,1-color);
				glVertex3f(vx/tSize*scale-0.7,vy/tSize*scale-0.7,-vz/tSize*scale);				
			}
		glEnd();
	}
	
	// swapping the buffers causes the rendering above to be 
	// shown
	glutSwapBuffers();
}


//--------------------------------------------------------------
//                          MAIN
//--------------------------------------------------------------
void main(int argc, char **argv) {

	theField.createTerrain();

	// GLUT
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(640,640);
	glutCreateWindow("TEST");		
	glutDisplayFunc(renderScene);   // register callback
	glEnable(GL_DEPTH_TEST);
	glRotatef(80.0f,1.0,0.0,1.0);	// define view angle
	glutMainLoop();
}
